(* Demo for ARDBCalendar
 Any Comments please contact me at;
 albertrs@redestb.es *)

unit Principal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons,  ExtCtrls, Grids, Calendar, DB,
  DBTables, DBCtrls, ARDBCalendar, Mask;

type

  TfrmPrincipal = class(TForm)
    TBL_CALENDARIO: TTable;
    TBL_CALENDARIOFEC_FEC: TStringField;
    TBL_CALENDARIOFEC_DIA01: TStringField;
    TBL_CALENDARIOFEC_DIA02: TStringField;
    TBL_CALENDARIOFEC_DIA03: TStringField;
    TBL_CALENDARIOFEC_DIA04: TStringField;
    TBL_CALENDARIOFEC_DIA05: TStringField;
    TBL_CALENDARIOFEC_DIA06: TStringField;
    TBL_CALENDARIOFEC_DIA07: TStringField;
    TBL_CALENDARIOFEC_DIA08: TStringField;
    TBL_CALENDARIOFEC_DIA09: TStringField;
    TBL_CALENDARIOFEC_DIA10: TStringField;
    TBL_CALENDARIOFEC_DIA11: TStringField;
    TBL_CALENDARIOFEC_DIA12: TStringField;
    TBL_CALENDARIOFEC_DIA13: TStringField;
    TBL_CALENDARIOFEC_DIA14: TStringField;
    TBL_CALENDARIOFEC_DIA15: TStringField;
    TBL_CALENDARIOFEC_DIA16: TStringField;
    TBL_CALENDARIOFEC_DIA17: TStringField;
    TBL_CALENDARIOFEC_DIA18: TStringField;
    TBL_CALENDARIOFEC_DIA19: TStringField;
    TBL_CALENDARIOFEC_DIA20: TStringField;
    TBL_CALENDARIOFEC_DIA21: TStringField;
    TBL_CALENDARIOFEC_DIA22: TStringField;
    TBL_CALENDARIOFEC_DIA23: TStringField;
    TBL_CALENDARIOFEC_DIA24: TStringField;
    TBL_CALENDARIOFEC_DIA25: TStringField;
    TBL_CALENDARIOFEC_DIA26: TStringField;
    TBL_CALENDARIOFEC_DIA27: TStringField;
    TBL_CALENDARIOFEC_DIA28: TStringField;
    TBL_CALENDARIOFEC_DIA29: TStringField;
    TBL_CALENDARIOFEC_DIA30: TStringField;
    TBL_CALENDARIOFEC_DIA31: TStringField;
    DBNavigator1: TDBNavigator;
    DTS_CALENDARIO: TDataSource;
    DBCA_Calendario: TARDBCalendar;
    GPB_DataSource: TGroupBox;
    CHB_Enabled: TRadioButton;
    CHB_Disabled: TRadioButton;
    GPB_Calendar: TGroupBox;
    CHB_EnabledC: TRadioButton;
    CHB_DisabledC: TRadioButton;
    Date: TLabel;
    BTN_Edit: TButton;
    DBE_DateInsert: TEdit;
    Label1: TLabel;
    BTN_Insert: TButton;
    BTN_Post: TButton;
    BTN_Cancel: TButton;
    GroupBox1: TGroupBox;
    CHB_EnabledP: TRadioButton;
    CHB_DisabledP: TRadioButton;
    Label2: TLabel;
    LAB_Marcados: TLabel;
    EDT_Date: TEdit;
    procedure CHB_EnabledClick(Sender: TObject);
    procedure CHB_DisabledClick(Sender: TObject);
    procedure CHB_EnabledCClick(Sender: TObject);
    procedure CHB_DisabledCClick(Sender: TObject);
    procedure EDT_DateExit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BTN_EditClick(Sender: TObject);
    procedure BTN_InsertClick(Sender: TObject);
    procedure BTN_PostClick(Sender: TObject);
    procedure BTN_CancelClick(Sender: TObject);
    procedure CHB_DisabledPClick(Sender: TObject);
    procedure CHB_EnabledPClick(Sender: TObject);
    procedure DBCA_CalendarioMarquedChange(Sender: TObject;
      Marqued: Integer);
    procedure DBCA_CalendarioPeriodRequest(Sender: TObject; var ActiveFrom,
      ActiveUntil: Integer; var NoneActive: Boolean);
    procedure DBCA_CalendarioDatePanelClick(Sender: TObject);
    procedure DBCA_CalendarioDaysClick(Sender: TObject;
      var DayClicked: Integer; var Change: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPrincipal: TfrmPrincipal;

implementation

{$R *.DFM}

procedure TfrmPrincipal.CHB_EnabledClick(Sender: TObject);
begin
	DTS_Calendario.Enabled := True;
end;

procedure TfrmPrincipal.CHB_DisabledClick(Sender: TObject);
begin
	DTS_Calendario.Enabled := False;
end;

procedure TfrmPrincipal.CHB_EnabledCClick(Sender: TObject);
begin
	DBCA_Calendario.Enabled := True;
end;

procedure TfrmPrincipal.CHB_DisabledCClick(Sender: TObject);
begin
	DBCA_Calendario.Enabled := False;
end;

procedure TfrmPrincipal.EDT_DateExit(Sender: TObject);
begin
	TBL_CALENDARIO.FindKey([EDT_Date.Text]);
end;

procedure TfrmPrincipal.FormShow(Sender: TObject);
begin
	CHB_EnabledC.Checked := True;
	CHB_Enabled.Checked := True;
	CHB_DisabledP.Checked := True;

	DTS_CALENDARIO.Enabled := True;
	DBCA_Calendario.Enabled := true;

	BTN_Insert.Enabled := True;
	BTN_Post.Enabled := False;
	BTN_Cancel.Enabled := False;
	BTN_Edit.Enabled := True;

end;

procedure TfrmPrincipal.BTN_EditClick(Sender: TObject);
begin
	TBL_CALENDARIO.Edit;
	BTN_Insert.Enabled := False;
	BTN_Edit.Enabled := False;
	BTN_Post.Enabled := True;
	BTN_Cancel.Enabled := True;
end;

procedure TfrmPrincipal.BTN_InsertClick(Sender: TObject);
begin
	if DBE_DateInsert.Text = '' then
		begin
			MessageDlg('No Value to Insert Specified',mtError,[mbOk],0);
		end;

	BTN_Edit.Enabled := False;
	BTN_Post.Enabled := True;
	BTN_Cancel.Enabled := True;

	TBL_CALENDARIO.Insert;
	TBL_CALENDARIO.FieldByName('FEC_FEC').AsString := DBE_DateInsert.Text;
end;

procedure TfrmPrincipal.BTN_PostClick(Sender: TObject);
begin
	TBL_CALENDARIO.Post;
	BTN_Edit.Enabled := True;
	BTN_Insert.Enabled := True;
	BTN_Cancel.Enabled := False;
	BTN_Post.Enabled := False;
end;

procedure TfrmPrincipal.BTN_CancelClick(Sender: TObject);
begin
	TBL_CALENDARIO.Cancel;
	BTN_Edit.Enabled := True;
	BTN_Insert.Enabled := True;
	BTN_Cancel.Enabled := False;
	BTN_Post.Enabled := False;

end;

procedure TfrmPrincipal.CHB_DisabledPClick(Sender: TObject);
begin
	DBCA_Calendario.AllowPeriodRequest := False;
end;

procedure TfrmPrincipal.CHB_EnabledPClick(Sender: TObject);
begin
	DBCA_Calendario.AllowPeriodRequest := True;
end;

procedure TfrmPrincipal.DBCA_CalendarioMarquedChange(Sender: TObject;
  Marqued: Integer);
begin
	LAB_Marcados.Caption := IntToStr(Marqued);
end;

procedure TfrmPrincipal.DBCA_CalendarioPeriodRequest(Sender: TObject;var ActiveFrom, ActiveUntil: Integer; var NoneActive: Boolean);
begin
	if TBL_CALENDARIO.FieldByName('FEC_FEC').AsString = '01/1997' then
		begin
			ActiveFrom := 1;
			ActiveUntil := 10;
		end;

	if TBL_CALENDARIO.FieldByName('FEC_FEC').AsString = '02/1997' then
		begin
			ActiveFrom := 11;
			ActiveUntil := 20;
			NoneActive := True;
		end;

	if TBL_CALENDARIO.FieldByName('FEC_FEC').AsString = '03/1997' then
		begin
			ActiveFrom := 21;
			ActiveUntil := 30;
		end;

	if TBL_CALENDARIO.FieldByName('FEC_FEC').AsString = '04/1997' then
		begin
			ActiveFrom := 30;
			ActiveUntil := 30;
		end;



end;

procedure TfrmPrincipal.DBCA_CalendarioDatePanelClick(Sender: TObject);
begin
	MessageDlg('You Clicked on the DatePanel',mtInformation,[mbOk],0);
end;

procedure TfrmPrincipal.DBCA_CalendarioDaysClick(Sender: TObject;var DayClicked: Integer; var Change: Boolean);
begin
	MessageDlg(Format('You Clicked on Day: %.2d',[DayClicked]),mtInformation,[mbOk],0);
end;

end.
